﻿using System;
using System.Runtime.InteropServices;

namespace WawaSoft.Net
{
    [Flags]
    internal enum SocketConstructorFlags
    {
        WSA_FLAG_MULTIPOINT_C_LEAF = 4,
        WSA_FLAG_MULTIPOINT_C_ROOT = 2,
        WSA_FLAG_MULTIPOINT_D_LEAF = 0x10,
        WSA_FLAG_MULTIPOINT_D_ROOT = 8,
        WSA_FLAG_OVERLAPPED = 1
    }
    [Flags]
    internal enum AsyncEventBits
    {
        FdAccept = 8,
        FdAddressListChange = 0x200,
        FdAllEvents = 0x3ff,
        FdClose = 0x20,
        FdConnect = 0x10,
        FdGroupQos = 0x80,
        FdNone = 0,
        FdOob = 4,
        FdQos = 0x40,
        FdRead = 1,
        FdRoutingInterfaceChange = 0x100,
        FdWrite = 2
    }

    [StructLayout(LayoutKind.Sequential)]
    internal struct WSAData
    {
        internal short wVersion;
        internal short wHighVersion;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 0x101)]
        internal string szDescription;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 0x81)]
        internal string szSystemStatus;
        internal short iMaxSockets;
        internal short iMaxUdpDg;
        internal IntPtr lpVendorInfo;
    }

    [StructLayout(LayoutKind.Sequential)]
    internal struct Linger
    {
        internal short OnOff;
        internal short Time;
    }
}
